<?php

date_default_timezone_set('UTC');

// get the time frame they're requesting, default to 30 seconds
// this is known as the 'period' in the SUP spec.
$age = (isset($_GET['age']) && is_numeric($_GET['age']) ? $_GET['age'] : 30);

// we also add 30 seconds to provide a good amount of overlap
$since_age = $age + 30;

function generate_sup_id($user_id) {
    return substr(md5('secret:' . $user_id), 0, 10);
}

function get_updates($since_age) {
    include_once("db.php");
    $db = new db('syndication_test', 'syndication_test', 'syntest');
    $sql = "SELECT id, last_update FROM users WHERE
            last_update > date_format(now() - INTERVAL {$since_age} SECOND,
                                      '%Y-%m-%d %H:%i%s')
            ORDER BY last_update DESC LIMIT 100";
    $updates = array();
    foreach ($db->select_array($sql) as $row) {
        $updates[] = array(generate_sup_id($row->id),
                           (string) strtotime($row->last_update));
    }
    return $updates;
}

$sup = new stdClass;
$sup->updated_time = date('Y-m-d\TH:i:s\Z');
$sup->since_time = date('Y-m-d\TH:i:s\Z', strtotime("-{$since_age} second"));
$sup->period = $age;
$sup->available_periods = new stdClass;
$host = (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '');
$url = 'http://' . $host . '/' . $_SERVER['PHP_SELF'];
$sup->available_periods->{'30'} = "{$url}?age=30";
$sup->available_periods->{'300'} = "{$url}?age=300";
$sup->available_periods->{'600'} = "{$url}?age=600";
$sup->updates = get_updates($since_age);

header("Content-Type: application/json");
print json_encode($sup);
