<?php

include_once("db.php");
$db = new db('syndication_test', 'syndication_test', 'syntest');

// make an API call to get a list of recently active users/feeds
$url = "http://enjoysthin.gs/api/active.users";
$data = json_decode(file_get_contents($url));
$feeds = array();
foreach ($data->users as $u) {
    $feeds[] = $u->atom;
}

echo("Checking for SUP-IDs on " . count($feeds) . " Atom feeds\n");

foreach($feeds as $feed) {
    // sup_discover is at the bottom of this file
    if ($sup_link = sup_discover($feed)) {
        list($sup_url, $sup_id) = explode("#", $sup_link);
        $data = array('feed_url' => $feed,
                      'sup_url'  => $sup_url,
                      'sup_id'   => $sup_id);
        $id = $db->insert_array('feeds', $data);
        echo("{$id} Found SUP-ID: ({$sup_id})\n");
    }
}

echo("Done.\n");

// Pass this function the URL of an Atom/RSS feed,
// and it will return the SUP-ID
function sup_discover($feed) {
    // download the feed as a PHP object
    $xml = @simplexml_load_file($feed);
    if (!$xml) {
        return false;
    }
    // initialize the variable
    $sup_link = false;

    // loop through the XML
    foreach ($xml as $k => $v) {
        // look for the link tag with SUP feed defined
        if ($k == 'link') {
            $attrs = $v->attributes();
            if ($attrs['rel'] == 'http://api.friendfeed.com/2008/03#sup') {
                return (string) $attrs['href'];
            }
        }
    }

    return false;
}
