// ========================================================================
// Copyright 2009 Ted Roden <tedroden@gmail.com>
// Based on code Copyright 2007-2008 Mort Bay Consulting Pty. Ltd.
// ------------------------------------------------------------------------
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//========================================================================

package com.tedroden.realtime;

import java.io.IOException;

import javax.servlet.GenericServlet;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletResponse;

import org.cometd.Bayeux;
import org.cometd.Client;
import org.cometd.Message;
import org.cometd.server.AbstractBayeux;
import org.cometd.server.BayeuxService;
// import org.cometd.server.ext.AcknowledgedMessagesExtension;
// import org.cometd.server.ext.TimesyncExtension;
import org.eclipse.jetty.util.log.Log;

public class EchoServlet extends GenericServlet
{
    public EchoServlet()
    {
    }

    @Override
    public void init() 
		throws ServletException
    {
        super.init();
        getServletContext().log("Configuring servlet");
        final Bayeux bayeux=(Bayeux)getServletContext().getAttribute(Bayeux.ATTRIBUTE);
        new EchoRPC(bayeux);
    }

    public static class EchoRPC extends BayeuxService
    {
        public EchoRPC(Bayeux bayeux)
        {
			//			getServletContext().log("EchoRPC");
            super(bayeux,"echo");
			Log.info("subscribing to /service/echo");
            subscribe("/service/echo","doEcho");
        }

        public Object doEcho(Client client, Object data)
        {
			Log.info("Doing echo");
			// getServletContext().log("Do Echo");
			//			Log.info("ECHO from "+client+" "+data);
			return data;
        }
    }

    @Override
    public void service(ServletRequest req, ServletResponse res) 
		throws ServletException, IOException
    {
        ((HttpServletResponse)res).sendError(503);
    }
}
