
var RIVER = {};
RIVER.onGoogleLoad =
	
	function() {

		// this gets called when dojo is loaded (below)
		function setupRiver() {
			// initialize cometd, the parameter is the comet service URL (relative path)
			dojox.cometd.init('cometd');

			// our river catcher
			var catcher = {
				handler: function(msg) {
					if (msg.data.content) {
						// container
						var p = dojo.create("p", {'style': 'opacity: 0' } );
						// author name
						dojo.create('strong',
									{ 'innerHTML': (msg.data.author ? msg.data.author : 'Anonymous') },
									p);
						// content
						dojo.create('p', { innerHTML: msg.data.content }, p);
						// put it in the stream
						dojo.place(p, "stream", 'first');
						// fade it in.
						dojo.fadeIn({ node: p, duration: 300 }).play();
					}
				}
			};

			// subscribe to the river of news channel, instruct it to call "catcher""
			// Params: channelName, objectForCallback, callbackFunction
			dojox.cometd.subscribe("/river/flow", catcher, "handler");
		}

		// ensure that the dojo framework is loaded
		// and run our setupt function
		dojo.addOnLoad(setupRiver);
		dojo.addOnUnload(dojox.cometd, "disconnect");

	};

// Using google to host the main JS files...
// so we wait for the google stuff to load
google.setOnLoadCallback(RIVER.onGoogleLoad);
