// ask google to load the jquery libraries
google.load("jquery", "1");

// when the library is loaded, get
// google.setOnLoadCallback(
//     function() { $(document).ready(cc.initialize); }
// );

var cc = {
	map: false,
	default_lat: 40.730521,
	default_lon: -73.984337
};

cc.initialize = function(map_div_id) {
    if (GBrowserIsCompatible()) {
        cc.map = new GMap2(document.getElementById(map_div_id));
        cc.map.setCenter(new GLatLng(cc.default_lat, cc.default_lon), 13);
		cc.map.setUIToDefault();
		cc.poll();
	}
	else
		alert("Google doesn't think your browser is compatible with their maps, this will be painful without them...");
};

cc.poll = function() {
	$.post('/get/nearby/germs/',
	{ 'lat': cc.default_lat, 'lon': cc.default_lon },
	cc.receivedGermData,
	'json');
};

cc.receivedGermData = function(data) {
	var message = data.message;
	var germs = data.germs;
	console.log(data);
	if(message) {
		alert(message);
	}

	cc.current_germ_threat = '';
	for(var i in germs) {
		if(germs[i].threat)
			cc.current_germ_threat = germs[i].id;

		cc.putGermOnMap(germs[i]);
	}
};



